#!/usr/local/bin/perl5 -w

# uses gnuplot to make a plot of a qlearn_compare_actmap.data file generated by
# the compare actmap mode in BaseQLearnBehavior.

# if outfn is missing, the datafn is used with any trailing .data deleted and .eps added
$usage = "$0 <datafn> <title> [<outfn>]";

# The graph shows a percentage of the states that are in the list. This is the maximum that can be
# be in. For the type of disable map where there is still an optimal policy, this is
# 9392. See coach/NOTES
$max_states_in = 9392;

$datafn= shift @ARGV;
$title = shift @ARGV;
$outfn = shift @ARGV;

die $usage if (not (defined($datafn)));

$title  = $datafn if (!defined($title));
if (!defined($outfn))
  {
    $outfn = $datafn;
    $outfn =~ s/\.data$//;
    $outfn .= '.eps';
  }

open (GPPROC, "|gnuplot") || die "Could not open gnuplot process";

print GPPROC <<EOF;
set term postscript eps 
set output '$outfn'

set nokey
set xlabel 'Time'
set ylabel '% of states with multiple optimal which are wrong'

set title '$title'
plot '$datafn' using (\$1/10):(\$2/$max_states_in) with lines


EOF

