/* A behavior to provide advice to execute a fixed policy
   Unlike AdiseFixedBehavior, the advice is given in state action form, and the coach
   randomly picks states to advise about */

#ifndef _ADVISE_FIXED_BEHAVIOR_H_
#define _ADVICE_FIXED_BEHAVIOR_H_

#include "Behavior.hpp"
#include "Policy.hpp"

//The behavior takes over responsibility for the memory here
class SAAdviseFixedBehavior : public Behavior
{
public:
  SAAdviseFixedBehavior(spadesalib::AgentCommInterface* pacs, const char* policy_fn);
  SAAdviseFixedBehavior(spadesalib::AgentCommInterface* pacs, Policy* p);
  ~SAAdviseFixedBehavior();
  
  void respondSense(Behavior::SenseType st);
  bool initialize();

  Policy* getPolicy() const { return ppolicy; }
  void forgetPolicy() { ppolicy = NULL; }

private:
  void adviseRandomStates(int num_states);
  
  Policy* ppolicy;
};


#endif
