/* This behavior is a virtual base class for qlearners built upon receiving coach messages
   about action advice that is state action pairs */

#ifndef _BASE_QLEARN_CSA_BEHAVIOR_H_
#define _BASE_QLEARN_CSA_BEHAVIOR_H_

#include <string>
#include <list>
#include "BaseQLearnBehavior.hpp"
#include "QTable.hpp"
#include "ActionSubsetMap.hpp"
#include "SAAdviceRepository.hpp"

class BaseQLearnCSABehavior : public BaseQLearnBehavior
{
public:
  BaseQLearnCSABehavior(spadesalib::AgentCommInterface* pacs,
			float gamma,
			explore_t exp, float alpha_explore, float boltzmann_constant);
  virtual ~BaseQLearnCSABehavior();

  void setSAAR(SAAdviceRepository* p);
  
  void setFinalAdviceFN(std::string fn) { final_advice_fn = fn; }

  void respondSenseQLearn(Behavior::SenseType st);
  virtual bool initialize();

  virtual void respondSenseCSA(Behavior::SenseType st) = 0;
  
protected:
  const SAAdviceRepository* getSAAR() const;

private:
  void processComm();

  SAAdviceRepository* psaar;

  std::string final_advice_fn;

};


#endif
