/* A behavior to execute a fixed policy */

#ifndef _FIXED_POLICY_BEHAVIOR_H_
#define _FIXED_POLICY_BEHAVIOR_H_

#include "Behavior.hpp"
#include "Policy.hpp"

//The behavior takes over responsibility for the memory here
class FixedPolicyBehavior : public Behavior
{
public:
  FixedPolicyBehavior(spadesalib::AgentCommInterface* pacs, const char* policy_fn);
  FixedPolicyBehavior(spadesalib::AgentCommInterface* pacs, Policy* p);
  ~FixedPolicyBehavior();
  
  void respondSense(Behavior::SenseType st);
  bool initialize();

  Policy* getPolicy() const { return ppolicy; }
  void forgetPolicy() { ppolicy = NULL; }

private:
  Policy* ppolicy;
};


#endif
