/* An event for the initial sensation for the agents
   Note that we don't have the usual CreateSenseEvent since this is only sent
   once at the beginning of the simulation */

#include <strstream>
#include "InitSenseEvent.hpp"

using namespace std;
using namespace spades;

InitSenseEvent::InitSenseEvent(spades::SimTime t, spades::AgentID a, int agentnum)
  : SenseEvent(TT_Regular, t, t, a), agentnum(agentnum)
{
  ostrstream o;

  o << "(init " << agentnum << ")" << ends;

  DataArray d(o);
  setData(d);
  //note that we do not unfreeze ostrstream since DataArray took it
}


void
InitSenseEvent::print (std::ostream & o) const
{
  o << "InitSenseEvent(ppagent: " << agentnum << ", ";
  SenseEvent::print(o);
  o << ")";
  
}



