/* This event randomly places the given agent on the field */

#ifndef _RANDOM_PLACE_EVENT_H_
#define _RANDOM_PLACE_EVENT_H_

#include "Event.hpp"

/* I'm not sure that this is the right thing. Right now you pass in a reference to an
   entity. THis means you can't creat this from a const method.
   I guess this is okay */

// in between act and sense
const spades::EventOrder EO_PLACE = 0x07500000;

class RandomPlaceEvent : public spades::Event
{
public:
  RandomPlaceEvent(spades::SimTime t, Entity& eref)
    : Event(t, EO_PLACE), entity(eref) {}
  
  ~RandomPlaceEvent() {}

  int getSecondaryOrder() const { return (int)entity.getID(); }
  
  void print (std::ostream & o) const
  { o << "RandomPlaceEvent(t:" << getTime() << ", " << entity << ")"; }

  //this is how the world model realizes the event
  bool realizeEventWorldModel(spades::WorldModel* pWM)
  {
    entity.setPosRandom();
    entity.clearMove();
    return true;
  }

private:
  Entity& entity;
  
};


#endif
