/* This is an act event for an agent to request an end to the simulation */

#ifndef _REQSHUTDOWN_ACT_EVENT_H_
#define _REQSHUTDOWN_ACT_EVENT_H_

#include "ActEvent.hpp"
#include "EndSimulationEvent.hpp"
#include "PPSharedTypes.hpp"
#include "PredPreyWorld.hpp"

class ReqShutdownActEvent : public spades::ActEvent
{
public:
  ReqShutdownActEvent (spades::SimTime t, spades::AgentID a)
    : ActEvent(t, a) {}
  ~ReqShutdownActEvent() {}

  void print (std::ostream & o) const
  { o << "ReqShutdownActEvent(t:" << getTime() << ", a:" << getAgent() << ")"; }

  //this is how the world model realizes the event
  bool realizeEventWorldModel(spades::WorldModel* pWM)
  {
    PredPreyWorld* p = (PredPreyWorld*)pWM;
    p->pSimEngine->enqueueEvent(new spades::EndSimulationEvent(p->pSimEngine->getSimulationTime()));
    return true;
  }
  
private:
  
};





#endif
